"twoislands" <-
function(
                     path,
                     npop1,
                     npop2,
                     nloci,
                     Theta=1, 
                     M=1, 
                     xpop1=4,
                     ypop=4,
                     d=2, 
                     s1=1,
                     s2=1,
                     plot=TRUE,
                     print=FALSE,
                     write=FALSE)
 {

     
       fst <- function(data,label){
               npop1<- length(which(label==1))
               npop2<- length(which(label==2))
               if(npop1!=0 & npop2!=0){ 
                         h1 <- 1 - sum( sapply( unique(data[which(label==1)]),FUN = function(i){sum( data[which(label==1)]==i)} )^2 )/npop1^2
                         h2 <- 1 - sum( sapply( unique(data[which(label==2)]),FUN = function(i){sum( data[which(label==2)]==i)} )^2 )/npop2^2
                         h <-  1 - sum( sapply( unique(data),FUN = function(i){sum(data==i)})^2)/length(data)^2
                         return((h-(h1+h2)/2)/h)
               }
               else return(NULL)
       }



       var.intra <- function(npop1, npop2, s1, s2){
               nindiv <- npop1 + npop2
               return((s1^2 * npop1 + s2^2 * npop2 )/nindiv)
       }


       var.inter <- function(npop1, npop2, xpop1, xpop2){
              nindiv <- npop1 + npop2
              return((npop1*xpop1^2 + npop2*xpop2^2 ) / nindiv  - ((npop1*xpop1  +  npop2*xpop2 ) / nindiv)^2)
       }


       
#Generates IAM mutations along a coalescent                                                                       
        iam <- function(tree,psi) {
#tree: a tree of coalescence generates according to migrate2
#psi: rate of mutation (the same in each population
     
       n <- dim(tree)[1]       
       Times <- tree[,3]       
       popmbrship <- tree[,1:2]
       
       Mut.type <- matrix(NA,nrow=n,ncol=2)

       p <- rpois(1,0.5*psi*(Times[n]-Times[n-1]))
       if(p==0) Mut.type[n,1] <- 1 else Mut.type[n,1] <- runif(1)
       p <- rpois(1,0.5*psi*(Times[n]-Times[n-1]))
       if(p==0) Mut.type[n,2] <- 1 else Mut.type[n,2] <- runif(1)


       for (i in (n-1):1){
                    test<- popmbrship==n+i+1
                    if (order(test)[2*n] > n)  {ancetre  <-  order(test)[2*n] - n} else {ancetre <-  order(test)[2*n]}
            
                    ind <- 1*sum(test[,1]) + 2*sum(test[,2])
                    
                    if ( tree[i,1] <= (n+1)) {
                            p <- rpois(1,0.5*psi*Times[i] )
                            if (p == 0) Mut.type[i,1] <- Mut.type[ancetre,ind] else Mut.type[i,1] <- runif(1)
                    }
                    if ( tree[i,1] > (n+1)) {
                            p <- rpois(1,0.5*psi*(Times[i]-Times[tree[i,1]-n-1]))
                            if (p == 0) Mut.type[i,1] <- Mut.type[ancetre,ind] else Mut.type[i,1] <- runif(1)
                    }
                    if ( tree[i,2] <= (n+1)) {
                              p <- rpois(1, 0.5 * psi * Times[i])
                              if (p == 0) Mut.type[i,2] <- Mut.type[ancetre,ind] else Mut.type[i,2]<- runif(1)                              
                    }
                    if ( tree[i,2] > (n+1)) { 
                           p <- rpois(1 , 0.5*psi*(Times[i]-Times[tree[i,2] - n - 1]))
                           if ( p == 0) Mut.type[i,2] <- Mut.type[ancetre,ind] else Mut.type[i,2] <- runif(1)
                     }
        }


                 X <- NULL
                 X[popmbrship[popmbrship[,1] <= (n +1),1]] <-  Mut.type[popmbrship[,1] <= (n +1), 1]
                 X[popmbrship[popmbrship[,2] <= (n +1),2]] <-  Mut.type[popmbrship[,2] <= (n +1), 2]
                 return(X)
   }



#Generates a structured coalescent for 2 populations in the form of a matrix with 3 columns                       
     migrate2 <- function(popmbrship,
                          c1=1, 
                          c2=1,     
                          m12=1, 
                          m21=1,
                          message=FALSE)
     {

            npop1<- length(which(popmbrship==1))
            npop2<- length(which(popmbrship==2))
            nindiv <- npop1 + npop2
            
            n.mig <- 0

#Initial populations
            pop1 <- which(popmbrship==1)
            pop2 <- which(popmbrship==2)
            
            Data <- matrix(NA, nrow = nindiv-1, ncol = 3)
            S <- 0

#A1 A2= number of ancestors in each population 

            A1 <- npop1
            A2 <- npop2
            
            i <- 1
            
            while ( A1 + A2 > 1 ){
              
                  lst <- c( A1*(A1-1)/2/c1, A2*(A2-1)/2/c2, A1*m12/2, A2*m21/2 )
                  proba <- lst/sum(lst)
                  cas <- sample(1:4, 1, prob = proba)
                  switch(cas,
                  {#coalpop1: Fusion of two lineages in population 1
                          Data[i, 1:2] <- xx <- sort(sample(pop1,2,replace= F))
                          #cat("coalesce =", xx,"\n" )
                          #Data[i,3] <- S <- S + rexp(1,  rate = A1*(A1-1)/2/c1) 
                          #Time of coalescence of two lineages in population 1
                          Data[i,3] <- S <- S + rexp(1,rate=sum(lst))  
                          pop1 <- c( pop1[ (pop1 !=xx[1]) & (pop1 != xx[2]) ], nindiv+i)
                          i <- i + 1
                          A1 <- A1 - 1
                   },
                   {#coalpop2: Fusion of two lineages in population 2
                          Data[i, 1:2] <- xx <- sort(sample(pop2, 2,replace= F))
                          #cat("coalesce =", xx,"\n" )
                          #Data[i,3] <- S <- S + rexp(1,  rate=A2*(A2-1)/2/c2)
                          #Time of coalescence of two lineages in population 2
                          Data[i,3] <- S <- S + rexp(1,rate=sum(lst) )
                          pop2 <- c( pop2[ (pop2 !=xx[1]) & (pop2 != xx[2]) ], nindiv+i)
                          i <- i + 1
                          A2 <- A2 - 1
                   },
                   {#mig12 (Migration of 1 individual from population1 to population 2)
                          if (length(pop1) > 1) xpop1 <- sample(pop1, 1) else xpop1 <- pop1
                          #S <- S + rexp(1,  rate = A1*m12/2)
                          S <- S + rexp(1,  rate = sum(lst) )
                          A1 <- A1 - 1
                          A2 <- A2 + 1
                          pop1 <- pop1[pop1 != xpop1]
                          pop2 <- c(pop2, xpop1)
                          n.mig <- n.mig + 1
                    },
                    {#mig21 (Migration of 1 individual from population 2 to population 1)
                          if (length(pop2) > 1) xpop2 <- sample(pop2, 1) else xpop2 <- pop2
                          #S <- S + rexp(1,  rate = A2*m21/2)
                          S <- S + rexp(1,  rate = sum(lst) )
                          A1 <- A1 + 1
                          A2 <- A2 - 1
                          pop2 <- pop2[pop2 != xpop2]
                          pop1 <- c(pop1, xpop2)
                          n.mig <- n.mig + 1
                     }
                     )


            #cat("A1 A2 = ", c(A1,A2), "\n")
            #cat("pop1 = ", pop1, "\n")
            #cat("pop2 = ", pop2, "\n")
            #cat("\n")
            }

            if(message==TRUE){
                          cat("nb migrations = ", n.mig, "\n")
            }

            return(Data)
       }



 

       z <- matrix(NA,nrow=npop1+npop2,ncol=2*nloci)

       xpop2<- xpop1+d

       x <- rnorm(npop1,xpop1,sd=s1)
       y <- rnorm(npop1,ypop,0.5*s1)

       w <- rnorm(npop2,xpop2,sd=s2)
       t <- rnorm(npop2,ypop,0.5*s2)

       x <- c(x,w)
       y <- c(y,t)
       x <- x - min(x,0)
       y <- y - min(y,0)

       coordinates<- matrix(nrow=npop1+npop2,ncol=2)
       coordinates[,1]<- x       
       coordinates[,2]<- y
               
       v <- var.intra(npop1,npop2, s1,s2)/var.inter(npop1,npop2,xpop1,xpop2)

       popmbrship<- c(rep(1,times=npop1),rep(2,times=npop2))
  
       for (i in 1:nloci){
            z[,2*i-1] <- as.integer(1000*iam(tree= migrate2(popmbrship,c1=1,c2=1,m12=M,m21=M,message=FALSE),psi=Theta))
            z[,2*i] <- as.integer(1000*iam(tree=migrate2(popmbrship,c1=1,c2=1,m12=M,m21=M,message=FALSE),psi=Theta))

       }

       format<-  FormatGenotypes(z) 
       z.format<- format$genotypes
       allele.numbers<- format$allele.numbers

           
       #Theoretical Fst
       Fst <- 1/(1+ 4*M + 2*Theta)

       #Estimated Fst
       fst.e <- NULL
       for (i in 1:(2*nloci)){
             fst.e[i] <- fst(z[,i],popmbrship) 
       }  

       if(is.null(s1)|is.null(s2)){ v=NULL }


       if(plot==TRUE){
                          X11()
                          title<- paste("2 iles with d=",d," s1=",s1," s2=",s2,"\n",sep="")      
                          e<-setplot(xdata=coordinates[,1],ydata=coordinates[,2])
                          par(pty="m",pin=e[[4]])                   
                          plot(coordinates,col=popmbrship,pch=20,xlab="",ylab="",main=title)   
                                
       }


       if(print==TRUE){
                          title<- paste("2 iles with d=",d," s1=",s1," s2=",s2,"\n",sep="") 
                          postscript(paste(path,"Spatial repartition.ps"))          
                          e<-setplot(xdata=coordinates[,1],ydata=coordinates[,2])
                          par(pty="m",pin=e[[4]])                   
                          plot(coordinates,col=popmbrship,pch=20,xlab="",ylab="",main=title)   
                          dev.off()                
       }

       if(write==TRUE){                   
                   write.table(coordinates,file=paste(path,"coordinates.txt",sep=""),col.names=FALSE,row.names=FALSE)
                   write.table(z.format,file=paste(path,"genotypes.txt",sep=""),col.names=FALSE,row.names=FALSE)
                   write(popmbrship,file=paste(path,"pop.mbrship.txt",sep=""))
                   write(allele.numbers,file=paste(path,"nall.txt",sep=""))
                         
                  # write parameters of the present simulation  in an ascii file
                  param <- c( paste("Number of loci:",nloci),
                              paste("Mutation rate :",Theta),
                              paste("Migration rate :",M),
                              paste("Theoretical Fst :",Fst),
                              paste("Empirical Fst :",mean(fst.e)),
                              paste("vintra/vinter:",v),
                              paste("d:",d))    
                  write.table(param,file=paste(path,"paramsimu.txt",sep=""),quote=FALSE,row.name=FALSE,col.name=FALSE)
        }        

        return(list(  coordinates=coordinates,
                      Fst=Fst,
                      meanfste=mean(fst.e),
                      v=v,
                      genotypes=z.format,
                      allele.numbers=allele.numbers,
                      popmbrship=popmbrship))                          
    }

