\name{as.geneclustdata}

\alias{as.geneclustdata}
%- Also NEED an '\alias' for EACH other topic documented here.

\title{Creates data objects for input to geneclust}

\description{This function creates objects of class \code{geneclustdata} for input to \code{geneclust}}

\usage{
as.geneclustdata(x,y,genotypes)
}

%- maybe also 'usage' for other objects documented here.
\arguments{
  
\item{x}{ spatial coordinates (x-axis) }

\item{y}{ spatial coordinates (y-axis) }

\item{genotypes}{ Matrix with rows corresponding to individuals and columns to loci }

}


\value{ An object of class \code{geneclustdata}.
}




\author{ Olivier Francois}

\seealso{Function \code{\link{geneclust}}}

\keyword{}

\examples{

# library(Geneclust)

\dontrun{

# Simulation of a dataset according to the prior distributions. This one
# is made of 2 populations (10 individuals)
# 5 loci and 10 alleles per loci
# on a spatial domain enclosed in a rectangle
# (x.coord. in [0,1], y.coord. in [0,1])
# Spatial interaction parameter is 0.5
# We suppose the inbreeding coefficients are the same in each population
# and equal to 0.1

#define a place for simulation outputs
path <- "./tmpData/"
system("mkdir ./tmpData/")


data<-simpatch(path=path,nindiv=10,npop=2,nall=rep(10,5),psi=0.5,fis=c(0.1,0.1),nchain=20000,burnin=10000,stepw=10,plot=FALSE)

datagc<- as.geneclustdata(data$coordinates[,1],data$coordinates[,2],data$genotypes)

datagc
}
}

