\name{is.geneclustdata}

\alias{is.geneclustdata}
%- Also NEED an '\alias' for EACH other topic documented here.

\title{Check data before input to geneclust}

\description{Check objects of class \code{geneclustdata} before input to \code{geneclust}}

\usage{
is.geneclustdata(obj)
}

%- maybe also 'usage' for other objects documented here.
\arguments{
  
\item{obj}{ Any object }

}


\value{ Logical \code{TRUE} if the object is correctly formatted before input to geneclust.
} 





\author{ Olivier Francois}

\seealso{Function \code{\link{geneclust}}}

\keyword{}

\examples{

# library(Geneclust)

\dontrun{

# Simulation of a dataset according to the prior distributions. This one
# is made of 2 populations
# 10 loci and 10 alleles per loci
# on a spatial domain enclosed in a rectangle
# (x.coord. in [0,1], y.coord. in [0,1])
# Spatial interaction parameter is 0.5
# We suppose the inbreeding coefficients are the same in each population
# and equal to 0.1

#define a place for simulation outputs
system("mkdir ./tmpData/")
path <- "./tmpData/"

data<-simpatch(path=path,nindiv=100,npop=2,nall=rep(10,10),psi=0.5,fis=c(0.1,0.1),nchain=20000,burnin=10000,stepw=10,plot=FALSE)


#To check data format
is.geneclustdata(data)


datagc<- as.geneclustdata(data$coordinates[,1],data$coordinates[,2],data$genotypes)

#To check data format
is.geneclustdata(datagc)

}
}
