\name{plot.geneclust}

\alias{plot.geneclust}
%- Also NEED an '\alias' for EACH other topic documented here.

\title{Display individual cluster memberships (spatial mapping)}

\description{Plot objects of class geneclust}

\usage{
plot.geneclust(obj, oneplot = TRUE, contour = TRUE, pts = TRUE)

}

%- maybe also 'usage' for other objects documented here.
\arguments{
  
\item{obj}{ Object of class \code{geneclust} }

\item{oneplot}{ If \code{TRUE} the maps are displayed in a single window}
 
\item{contour}{ If \code{TRUE} contour lines are displayed}

\item{pts}{ If \code{TRUE} individual locations are shown}

}


\value{ Two dimensional plots of cluster memberships and interpolate the  membership probability coefficients.
}


\details{Make uses of functions from the package \code{spatial} to interpolate membership coefficients.}


\author{ Olivier Francois}

\seealso{Function \code{\link{geneclust}}}

\keyword{}

\examples{

# library(Geneclust)

\dontrun{

# Simulation of a dataset according to the prior distributions. This one
# is made of 2 populations
# 10 loci and 10 alleles per loci
# on a spatial domain enclosed in a rectangle
# (x.coord. in [0,1], y.coord. in [0,1])
# Spatial interaction parameter is 0.5
# We suppose the inbreeding coefficients are the same in each population
# and equal to 0.1

system("mkdir ./tmpData/")
path <- "./tmpData/"

data<-simpatch(path=path,nindiv=100,npop=2,nall=rep(10,10),psi=0.5,fis=c(0.1,0.1),nchain=20000,burnin=10000,stepw=10,plot=FALSE)

datagc<- as.geneclustdata(data$coordinates[,1],data$coordinates[,2],data$genotypes)


#To run Full Bayesian Markov Chain Monte Carlo inference of all
#parameters 
geneclustobj1<-geneclust("MCMC1",datagc,npop=5,nit=3000,burnin=200,thinning=5,varfis=FALSE,varpsi=FALSE)

plot(geneclustobj1)

}

}
