\name{print.geneclust}
\alias{print.geneclust}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Describes an object of class geneclust or structure}
\description{
 This function describes an object of class geneclust (or of class
 structure). It indicates the number of individuals, the number of
 clusters detected and the average loglikelihood reached after an MCMC run
}
\usage{
print.geneclust(obj)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{obj}{Object of class \code{geneclustdata}  }
}

\author{ Olivier François }

\keyword{}

\examples{

# library(Geneclust)
\dontrun{

# Simulation of a dataset according to the prior distributions. This one
# is made of 2 populations
# 10 loci and 10 alleles per loci
# on a spatial domain enclosed in a rectangle
# (x.coord. in [0,1], y.coord. in [0,1])
# Spatial interaction parameter is 0.5
# We suppose the inbreeding coefficients are the same in each population
# and equal to 0.1

system("mkdir ./tmpData/")
path <- "./tmpData/"
data<- simpatch(path=path,nindiv=100,npop=2,nall=rep(10,10),psi=0.5,fis=c(0.1,0.1),plot=FALSE,chain=20000,burnin=10000,stepw=10)
datagc<- as.geneclustdata(data$coordinates[,1],data$coordinates[,2],data$genotypes)

geneclustobj<-geneclust("MCMC",datagc,npop=5,nit=3000,burnin=200,thinning=5,varfis=FALSE,varpsi=FALSE,otherconfig=NULL)

print.geneclust(geneclustobj)

}
}